.versioning:
  image: registry.gitlab.com/devops-kodcode/poc/ubuntu.22.04-git-yq-release-cli:1.0.1

  before_script:
    - git config --global user.email "dssopher@gmail.com"
    - git config --global user.name "David Sopher"
  script: 
    - export CHANGED_SERVICES=$(git diff --name-only HEAD^ HEAD | awk -F/ '{print $1}' | uniq)
    - |
      for SERVICE in ${CHANGED_SERVICES[@]}; do
        NEW_VERSION=$(yq -oy .version "$SERVICE/package.json" | awk -F. '{print $1 "." $2 "." $3+1}')
        echo "The new version of your project is: $NEW_VERSION"
        yq -oj ".version = \"$NEW_VERSION\"" "$SERVICE/package.json" -i
      done
    - NEW_VERSION=$(yq -oy .version package.json | awk -F. '{print $1 "." $2 "." $3+1}')
    - yq -oj ".version = \"$NEW_VERSION\"" package.json -i
    - git pull origin main
    - git commit -am "update version for $CHANGED_SERVICES and for main package"
    - echo "https://oauth2:${ACCESS_REDDIT}@gitlab.com/${CI_PROJECT_PATH}.git"
    - git push "https://oauth2:${ACCESS_REDDIT}@gitlab.com/${CI_PROJECT_PATH}.git" HEAD:main -o ci.skip